/*
 * Copyright (C) 2017-2018 Yantra Cloud Ltd. <https://yantra.cloud>
 */

package cloud.yantra.patterns.actors.validations

import akka.actor.{Actor, ActorRef, Props}
import cloud.yantra.patterns.actors.validations.ValidationRuleWorker._
import cloud.yantra.patterns.cqrs._

/**
  * An [[Actor]] based implementation of [[Rule]] validation.
  * This will be a stateless actor, and used by [[CommandValidation]] for getting [[Rule]] validated during processing of a [[Command]]
  * in an [[Actor]] based [[akka.actor.ActorSystem]]
  */
class ValidationRuleWorker(rule: Rule, master: ActorRef) extends Actor {

  override def receive: Receive = {
    case InitiateValidation =>
      resultState = rule.validate()
      master ! WorkerFinishedValidation(rule, resultState)

    case GetValidationResult(observer) =>
      resultState match {
        case NotEvaluated => observer.getOrElse(sender) ! WorkerWaitingInitiation(rule)
        case _ => observer.getOrElse(master) ! WorkerFinishedValidation(rule, resultState)
      }
  }

  /**
    * Stores the result post evaluation of [[ValidationRule]] present in [[Rule]]
    */
  private var resultState: Result = NotEvaluated
}

case object ValidationRuleWorker {

  def props(rule: Rule, observer: ActorRef): Props = Props(new ValidationRuleWorker(rule, observer))

  /**
    * Commands accepted by [[ValidationRuleWorker]]
    */
  sealed trait WorkerCommand extends Serializable

  /**
    * Initiates the [[ValidationRuleWorker]]
    */
  case object InitiateValidation extends WorkerCommand

  /**
    * [[ValidationRuleWorker]] generates [[WorkerEvent]] with appropriate stage
    *
    * @param observer
    */
  case class GetValidationResult(observer: Option[ActorRef] = None) extends WorkerCommand

  /**
    * Events generated by [[ValidationRuleWorker]]
    */
  sealed trait WorkerEvent extends Serializable {

    def rule: Rule

    def result: Result
  }

  /**
    * [[WorkerEvent]] representing that [[ValidationRuleWorker]] has not been initiated
    *
    * @param rule
    */
  case class WorkerWaitingInitiation(rule: Rule) extends WorkerEvent {
    override def result: Result = NotEvaluated
  }

  /**
    * [[WorkerEvent]] representing containing the state of [[ValidationRuleWorker]] after evaluation of [[Rule]]
    *
    * @param rule
    * @param result
    */
  case class WorkerFinishedValidation(rule: Rule, result: Result) extends WorkerEvent

}
